/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package es.uja.ssmmaa.curso1920.juegotablero.gui;

import es.uja.ssmmaa.curso1920.juegotablero.agentes.AgenteMonitor;
import static es.uja.ssmmaa.curso1920.ontologia.Vocabulario.JUEGOS;
import es.uja.ssmmaa.curso1920.ontologia.Vocabulario.TipoJuego;
import es.uja.ssmmaa.curso1920.ontologia.Vocabulario.TipoServicio;
import jade.core.AID;
import java.util.Deque;

/**
 *
 * @author pedroj
 */
public class RegistroAgentesJFrame extends javax.swing.JFrame {
    private final AgenteMonitor agente;
    private final AgentesJuegoJPanel[] juegos;
    private OkCancelDialog finalizacion;

    /**
     * Creates new form TiposAgentesJFrame
     */
    public RegistroAgentesJFrame(AgenteMonitor agente) {
        super("Agentes localizados por: " + agente.getName());
        
        initComponents();
        this.agente = agente;
        
        // Inicializamos los paneles para el registro de los agentes del juego
        juegos = new AgentesJuegoJPanel[JUEGOS.length];
        for(int i = 0; i < JUEGOS.length; i++) {
            juegos[i] = new AgentesJuegoJPanel();
            this.jTabbedPane1.add(JUEGOS[i].name(), juegos[i]);
        } 
        
        this.finalizacion = null;
        setVisible(true);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTabbedPane1 = new javax.swing.JTabbedPane();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setAlwaysOnTop(true);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 568, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 588, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        // TODO add your handling code here:
        finalizacion = new OkCancelDialog(this, true, agente);
        finalizacion.setVisible(true);
    }//GEN-LAST:event_formWindowClosing

    public void addAgentes(TipoJuego juego, TipoServicio servicio, Deque<AID> listaAgentes) {
        juegos[juego.ordinal()].addAgentes(servicio, listaAgentes);
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTabbedPane jTabbedPane1;
    // End of variables declaration//GEN-END:variables
}
